Subject: Re: [RFC] add rtnl semaphore to linux-atm

From: "David S. Miller" <[email-masked]>
Date: Wed, 1 Oct 2003 06:14:26 -0700

On Wed, 01 Oct 2003 09:07:45 -0400
chas williams <[email-masked]> wrote:

> i had initially written it that way but remembered at one point i
> was going to use the rtnl semaphore to handle this problem.  any
> opinions on what is 'better'?

Blocking all network configuration operations (even ones not
for your subsystem) is a little bit anti-social in SMP cases.

If you take the rwlock as a reader, you only interfere with a
very minute class of network configuration code paths (those that
need to take the rwlock in question as a writer).

For example, if you use the rwlock-as-reader approach, someone doing
IPV4 routing table updates (ie. routing daemon changing a couple
thousand routes after a BGP flap) won't be perturbed while the ATM
operation is in progress.